"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator.throw(value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments)).next());
    });
};
const got = require('got');
const urlJoin = require('url-join');
let DEFAULT_EP = 'https://gitlab.com/api/v3';
let { EP = DEFAULT_EP, GITLAB_PRIVATE_TOKEN } = process.env;
let g = (p, param) => (body) => __awaiter(this, void 0, void 0, function* () {
    let opt = Object.assign({
        headers: {
            'PRIVATE-TOKEN': GITLAB_PRIVATE_TOKEN
        },
        json: true
    }, param, { body });
    return yield got(urlJoin(EP, p), opt).then(resp => resp.body);
});
let e = (arg) => encodeURIComponent(arg);
let gp = (q = '', opt) => g(`projects/${q}`, opt);
exports.GitLabApi = {
    projects: {
        visible: gp('visible'),
        owned: gp('owned'),
        starred: gp('starred'),
        all: gp('all'),
        get: (id, opt) => gp(e(id))(opt),
        getEvent: (id, opt) => gp(`${e(id)}/events`)(opt),
        getHook: (id, opt) => gp(`${e(id)}/hooks`)(opt),
        getHookById: (id, hookId, opt) => gp(`${e(id)}/hooks/${e(hookId)}`)(opt),
        create: gp('', { method: 'post' }),
        createHook: (id, opt) => gp(`${e(id)}/hooks`)(opt),
        createForUser: (uId, opt) => gp(`user/${e(uId)}`, { method: 'post' })(opt),
        fork: (pId, opt) => gp(`fork/${e(pId)}`)(opt),
        star: (pId, opt) => gp(`${e(pId)}/star`, { method: 'post' })(opt),
        unstar: (pId, opt) => gp(`${e(pId)}/star`, { method: 'delete' })(opt),
        delete: (id, opt) => gp(e(id), { method: 'delete' })(opt),
        search: (query, opt) => gp(`search/${e(query)}`)(opt),
    }
};
